include <structures.wdl>;

bmap bmap_lvl2_levelEnd = <lvl2_levelende.bmp>;
font font_lvl2_levelEnd, <font_lvl2_Levelende.bmp>, 21, 22;



var lvl2_tri_LevelEnd_to_x[2];
var lvl2_tri_LevelEnd_to_y[2];
var lvl2_tri_LevelEnd_to_z[2];


sound get_report_lvl2 = <getreport.wav>;
var get_report_lvl2_handle;


// Panels

// panel levelEnd

panel pan_lvl2_levelEnd
{
	bmap = bmap_lvl2_levelEnd;
	pos_x = -600;
	pos_y = 0;
	digits = 118,50,2, font_lvl2_levelEnd, 1, lvl2_ReportsFound;
	digits = 150,50,2, font_lvl2_levelEnd, 1, lvl2_ReportsNumber;
	flags = refresh, visible;
}


// reports 

function event_Report_lvl2            // // only the play can collect reports
{                                 
	if (you == player)         
	{
		Report_lvl2[my.skill1] = 1;
		lvl2_ReportsFound += 1;
		
		my.invisible = on;
		my.passable = on;
		
		get_report_lvl2_handle = snd_play(get_report_lvl2,100,0);
	}
}


define ReportNr, skill1;
define Area, skill2;
//uses: ReportNr,Area;
action lvl2_Report
{
	my.enable_impact = on;
	my.event = event_Report_lvl2;
	
	while(Report_lvl2[my.ReportNr] == 0)  
	{                 
		if (activeArea[my.Area] == 0)           // if area is active
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}                 
		wait(1);
	}
	
}






// special action to combine a special object with a button
define SpecialObjectNr, skill1;
define WaitBeforeStart, skill2;
define MoveToNachX, skill3;
define WaitBeforeBack, skill4;
define Area, skill5;
//uses: SpecialObjectNr,WaitBeforeStart, MoveToX, WaitBeforeBack, Area;
action lvl2_r1_sobj
{
	my.skill90 = my.x;  
	my.skill91 = my.y;
	my.skill92 = my.z;
	
	
	while(1)
	{
		if (menu_active == 0)
		{
		
		if (activeArea[my.Area] == 0)           // if area is active
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if (SpecialObject_ActivateWithNumber[my.SpecialObjectNr] == 1)
		{
			sleep(my.WaitBeforeStart);
			SpecialObject_IsMoving[my.SpecialObjectNr] = 1;
			
			
			while(my.x > my.MoveToX)
			{
				if (menu_active == 0)
				{
				
				my.x -= 2 * time;
				}
				wait(1);
			}
			my.x = my.MoveToX;
			sleep(my.WaitBeforeBack);
			
			while(my.x < my.skill90)
			{
				if (menu_active == 0)
				{
				
				my.x += 2 * time;
				}
				wait(1);
			}
			my.x = my.skill90;
			
			
				SpecialObject_ActivateWithNumber[my.SpecialObjectNr] = 0;
				SpecialObject_IsMoving[my.specialObjectNr] = 0;
			
		}
		}
		wait(1);
	}
}






// trigger to display the levelend

action lvl2_tri_LE_on_f // lvl2 = Level 2; tri = trigger; LE = LevelEnd; on = activate; f = from
{
	wait(2);
	trace_mode = ignore_me + ignore_passable + ignore_passents + ignore_sprites + use_box + activate_shoot;
	
	while(1)
	{
		if (vec_dist(my.x, player.x) < 200) // if player in the near
		{													 
			trace(my.x, vector(lvl2_tri_LevelEnd_to_x[0],lvl2_tri_LevelEnd_to_y[0],lvl2_tri_LevelEnd_to_z[0]));
			
		
			if (you == player)
			{
				pan_lvl2_levelEnd.pos_x = RoundValue((screen_size.x - 251) /2);
				pan_lvl2_levelEnd.pos_y = RoundValue((screen_size.y - 98) /2);
				
				
				
				
			}
			
			if  (pausemenu_active == 1)
			{
				pan_lvl2_levelEnd.pos_x = -2000;
			}
			
		}
		wait(1);
	}
}


action lvl2_tri_LE_on_t // lvl2 = Level 2; tri = trigger; LE = LevelEnd; on = activate; t = to
{
	lvl2_tri_LevelEnd_to_x[0] = my.x;
	lvl2_tri_LevelEnd_to_y[0] = my.y;
	lvl2_tri_LevelEnd_to_z[0] = my.z;
}

action lvl2_tri_LE_off_f 
{
	wait(2);
	trace_mode = ignore_me + ignore_passable + ignore_passents + ignore_sprites + use_box + activate_shoot;
	
	while(1)
	{
		if (vec_dist(my.x, player.x) < 200) // if player in the near
		{													 
			trace(my.x, vector(lvl2_tri_LevelEnd_to_x[1],lvl2_tri_LevelEnd_to_y[1],lvl2_tri_LevelEnd_to_z[1]));
			
		
			if (you == player)
			{
				pan_lvl2_levelEnd.pos_x = -600;
				
				
			}
		}
		wait(1);
	}
}


action lvl2_tri_LE_off_t // ( lvl2 = Level 2; tri = trigger; off = deactivate; t = to)
{
	lvl2_tri_LevelEnd_to_x[1] = my.x;
	lvl2_tri_LevelEnd_to_y[1] = my.y;
	lvl2_tri_LevelEnd_to_z[1] = my.z;
}



//trigger action to load startlevel ( mainmenu )
define Area, skill1;
define Triggerpair, skill2;
// uses: Triggerpair
action trigg_lvlStartLoad
{
	var GebietAusschalten;
	var ZielPos[3];
	
	wait(2);
	trace_mode = ignore_me + ignore_passable + ignore_passents + ignore_sprites + use_box + activate_shoot;
	
	
	while(1)
	{
		if (vec_dist(my.x, player.x) < 200) // if player in the near
		{													 
		
			trace(my.x, vector(tri_to_x[my.Triggerpair],tri_to_y[my.Triggerpair],tri_to_z[my.Triggerpair]));
			
		
			if (you == player && lvl2_ReportsFound == lvl2_ReportsNumber)
			{
				pan_lvl2_levelEnd.pos_x = 2000;
				load_level0();
				
				
			}
			
			while (you != null && you !=player && vec_dist(my.x, player.x) < 2000)
			{
				vec_set(ZielPos, target);
				trace(target, vector(tri_to_x[my.Triggerpair],tri_to_y[my.Triggerpair],tri_to_z[my.Triggerpair]));
			
				wait(1);
				vec_set(target, ZielPos);
			}
		}

		wait(1);
	}
	
	
}

define Triggerpair, skill2;
// uses: Triggerpair
action trigg_to_lvlStart
{
	tri_to_x[my.Triggerpair] = my.x;
	tri_to_y[my.Triggerpair] = my.y;
	tri_to_z[my.Triggerpair] = my.z;
	wait(1);
}
