include <structures.wdl>;

sound hm_bg_music = <hm_bg_music.wav>;
var_nsave hm_bg_music_handle;


font font_optionsmenu, <font_optionsmenu.bmp>, 8, 15;

// bitmaps mainmenu

bmap btn_NewGame_normal_tga = <btn_GameNew_normal_tga.tga>;
bmap btn_NewGame_clicked_tga = <btn_GameNew_clicked_tga.tga>;
bmap btn_NewGame_over_tga = <btn_GameNew_over_tga.tga>;

bmap btn_GameLoad_normal_tga = <btn_GameLoad_normal_tga.tga>;
bmap btn_GameLoad_clicked_tga = <btn_GameLoad_clicked_tga.tga>;
bmap btn_GameLoad_over_tga = <btn_GameLoad_over_tga.tga>;

bmap btn_Optionen_normal_tga = <btn_GameOptions_normal_tga.tga>;
bmap btn_Optionen_clicked_tga = <btn_GameOptions_clicked_tga.tga>;
bmap btn_Optionen_over_tga = <btn_GameOptions_over_tga.tga>;

bmap btn_Beenden_normal_tga = <btn_GameExit_normal_tga.tga>;
bmap btn_Beenden_clicked_tga = <btn_GameExit_clicked_tga.tga>;
bmap btn_Beenden_over_tga = <btn_GameExit_over_tga.tga>;

// background images

bmap hm_bg_image = <hm_bg.tga>;    // mainmenu
bmap pm_bg_image = <pm_bg.tga>;    // pausemenu
bmap om_bg_image = <om_bg.tga>;    // optionsmenu
bmap lm_bg_image = <lm_bg.tga>;    // loadmenu
bmap sa_bg_image = <sa_bg.tga>;    // saveas menu

// bitmaps pausemenu

bmap btn_toMainMenu_normal_tga = <btn_mainmenu_normal_tga.tga>;
bmap btn_toMainMenu_clicked_tga = <btn_mainmenu_clicked_tga.tga>;
bmap btn_toMainMenu_over_tga = <btn_mainmenu_over_tga.tga>;

bmap btn_playagain_normal_tga = <btn_resume_normal_tga.tga>;
bmap btn_playagain_clicked_tga = <btn_resume_clicked_tga.tga>;
bmap btn_playagain_over_tga = <btn_resume_over_tga.tga>;

bmap btn_saveas_normal_tga = <btn_saveas_normal_tga.tga>;
bmap btn_saveas_clicked_tga = <btn_saveas_clicked_tga.tga>;
bmap btn_saveas_over_tga = <btn_saveas_over_tga.tga>;

// bitmaps optionsmenu

bmap btn_om_640x480_n = <btn_om_640x480_n.tga>;   // _n = normal
bmap btn_om_640x480_c = <btn_om_640x480_c.tga>;   // _c = clicked
bmap btn_om_640x480_o = <btn_om_640x480_o.tga>;   // _o = over

bmap btn_om_800x600_n = <btn_om_800x600_n.tga>;   // _n = normal
bmap btn_om_800x600_c = <btn_om_800x600_c.tga>;   // _c = clicked
bmap btn_om_800x600_o = <btn_om_800x600_o.tga>;   // _o = over

bmap btn_om_1024x768_n = <btn_om_1024x768_n.tga>; // _n = normal
bmap btn_om_1024x768_c = <btn_om_1024x768_c.tga>; // _c = clicked
bmap btn_om_1024x768_o = <btn_om_1024x768_o.tga>; // _o = over

bmap btn_om_1280x960_n = <btn_om_1280x960_n.tga>; // _n = normal
bmap btn_om_1280x960_c = <btn_om_1280x960_c.tga>; // _c = clicked
bmap btn_om_1280x960_o = <btn_om_1280x960_o.tga>; // _o = over

bmap btn_om_apply_n = <btn_om_apply_n.tga>;  // ... 
bmap btn_om_apply_c = <btn_om_apply_c.tga>;
bmap btn_om_apply_o = <btn_om_apply_o.tga>;

bmap btn_om_16bit_n = <btn_om_16bit_n.tga>;
bmap btn_om_16bit_c = <btn_om_16bit_c.tga>;
bmap btn_om_16bit_o = <btn_om_16bit_o.tga>;

bmap btn_om_32bit_n = <btn_om_32bit_n.tga>;
bmap btn_om_32bit_c = <btn_om_32bit_c.tga>;
bmap btn_om_32bit_o = <btn_om_32bit_o.tga>;

bmap btn_om_fullscreen_n = <btn_om_fullscreen_n.tga>;
bmap btn_om_fullscreen_c = <btn_om_fullscreen_c.tga>;
bmap btn_om_fullscreen_o = <btn_om_fullscreen_o.tga>;

bmap btn_om_playerforward_n = <btn_om_playerforward_n.tga>;
bmap btn_om_playerforward_c = <btn_om_playerforward_c.tga>;
bmap btn_om_playerforward_o = <btn_om_playerforward_o.tga>;

bmap btn_om_playerbackward_n = <btn_om_playerbackward_n.tga>;
bmap btn_om_playerbackward_c = <btn_om_playerbackward_c.tga>;
bmap btn_om_playerbackward_o = <btn_om_playerbackward_o.tga>;

bmap btn_om_playerstepleft_n = <btn_om_playerstepleft_n.tga>;
bmap btn_om_playerstepleft_c = <btn_om_playerstepleft_c.tga>;
bmap btn_om_playerstepleft_o = <btn_om_playerstepleft_o.tga>;

bmap btn_om_playerstepright_n = <btn_om_playerstepright_n.tga>;
bmap btn_om_playerstepright_c = <btn_om_playerstepright_c.tga>;
bmap btn_om_playerstepright_o = <btn_om_playerstepright_o.tga>;

bmap btn_om_playeruse_n = <btn_om_playeruse_n.tga>;
bmap btn_om_playeruse_c = <btn_om_playeruse_c.tga>;
bmap btn_om_playeruse_o = <btn_om_playeruse_o.tga>;

bmap btn_om_playerjump_n = <btn_om_playerjump_n.tga>;
bmap btn_om_playerjump_c = <btn_om_playerjump_c.tga>;
bmap btn_om_playerjump_o = <btn_om_playerjump_o.tga>;

bmap btn_om_playerweapon1_n = <btn_om_playerweapon1_n.tga>;
bmap btn_om_playerweapon1_c = <btn_om_playerweapon1_c.tga>;
bmap btn_om_playerweapon1_o = <btn_om_playerweapon1_o.tga>;

bmap btn_om_playerweapon2_n = <btn_om_playerweapon2_n.tga>;
bmap btn_om_playerweapon2_c = <btn_om_playerweapon2_c.tga>;
bmap btn_om_playerweapon2_o = <btn_om_playerweapon2_o.tga>;

bmap btn_om_playerweapon3_n = <btn_om_playerweapon3_n.tga>;
bmap btn_om_playerweapon3_c = <btn_om_playerweapon3_c.tga>;
bmap btn_om_playerweapon3_o = <btn_om_playerweapon3_o.tga>;

bmap btn_om_playerweapon4_n = <btn_om_playerweapon4_n.tga>;
bmap btn_om_playerweapon4_c = <btn_om_playerweapon4_c.tga>;
bmap btn_om_playerweapon4_o = <btn_om_playerweapon4_o.tga>;

bmap btn_om_window_n = <btn_om_window_n.tga>;
bmap btn_om_window_c = <btn_om_window_c.tga>;
bmap btn_om_window_o = <btn_om_window_o.tga>;

bmap btn_om_close_n = <btn_om_close_n.tga>;
bmap btn_om_close_c = <btn_om_close_c.tga>;
bmap btn_om_close_o = <btn_om_close_o.tga>;

bmap btn_om_circle = <btn_om_circle.tga>;


// bitmaps gameloadmenu

bmap btn_slot1_normal = <btn_slot1_normal.tga>;
bmap btn_slot1_over = <btn_slot1_over.tga>;
bmap btn_slot2_normal = <btn_slot2_normal.tga>;
bmap btn_slot2_over = <btn_slot2_over.tga>;
bmap btn_slot3_normal = <btn_slot3_normal.tga>;
bmap btn_slot3_over = <btn_slot3_over.tga>;
bmap btn_slot4_normal = <btn_slot4_normal.tga>;
bmap btn_slot4_over = <btn_slot4_over.tga>;
bmap btn_slot5_normal = <btn_slot5_normal.tga>;
bmap btn_slot5_over = <btn_slot5_over.tga>;
bmap btn_slot6_normal = <btn_slot6_normal.tga>;
bmap btn_slot6_over = <btn_slot6_over.tga>;
bmap btn_slot7_normal = <btn_slot7_normal.tga>;
bmap btn_slot7_over = <btn_slot7_over.tga>;
bmap btn_slot8_normal = <btn_slot8_normal.tga>;
bmap btn_slot8_over = <btn_slot8_over.tga>;
bmap btn_slot9_normal = <btn_slot9_normal.tga>;
bmap btn_slot9_over = <btn_slot9_over.tga>;
bmap btn_slot10_normal = <btn_slot10_normal.tga>;
bmap btn_slot10_over = <btn_slot10_over.tga>;

bmap btn_lm_laden_normal = <btn_lm_load_normal.tga>;
bmap btn_lm_laden_clicked = <btn_lm_load_clicked.tga>;
bmap btn_lm_laden_over = <btn_lm_load_over.tga>;

bmap btn_lm_close_normal = <btn_lm_close_normal.tga>;
bmap btn_lm_close_clicked = <btn_lm_close_clicked.tga>;
bmap btn_lm_close_over = <btn_lm_close_over.tga>;


//bitmaps gamesaveasmenu ( sa = save as )

bmap btn_sa_close_n = <btn_sa_close_n.tga>;
bmap btn_sa_close_c = <btn_sa_close_c.tga>;
bmap btn_sa_close_o = <btn_sa_close_o.tga>;


// bitmap SaveInfo

bmap bmap_SaveInfo = <SaveInfo.tga>;



panel pan_mainmenu
{
	bmap = hm_bg_image;
	button 438,205, btn_NewGame_clicked_tga, btn_NewGame_over_tga, btn_NewGame_normal_tga, load_level1, null, null;
	button 438,268, btn_GameLoad_clicked_tga, btn_GameLoad_over_tga, btn_GameLoad_normal_tga, GameLoadMenu_activate, null, null;
	button 438,330, btn_Optionen_clicked_tga, btn_Optionen_over_tga, btn_Optionen_normal_tga, Optionsmenu_activate, null, null;
	button 438,394, btn_Beenden_clicked_tga, btn_Beenden_over_tga, btn_Beenden_normal_tga, GameExit, null, null;
	pos_x = 0; 
	pos_y = 0;
	layer = 1;
	flags = refresh, visible;
}

panel pan_pausemenu
{
	bmap = pm_bg_image;
	button 304,235, btn_toMainMenu_clicked_tga, btn_toMainMenu_over_tga, btn_toMainMenu_normal_tga, load_level0, null, null;
	button 328,275, btn_playagain_clicked_tga, btn_playagain_over_tga, btn_playagain_normal_tga, resume, null, null;
	button 328,315, btn_saveas_clicked_tga, btn_saveas_over_tga, btn_saveas_normal_tga, GameSaveAsMenu_activate, null, null;
	pos_x = 2000; 
	pos_y = 0;
	layer = 2;
	flags = refresh, visible;
}

panel pan_options
{
	bmap = om_bg_image; // om = optionsmenu -> bg = background
	button 180,160, btn_om_640x480_c, btn_om_640x480_o, btn_om_640x480_n, Resolution6, null, null;
	button 180,180, btn_om_800x600_c, btn_om_800x600_o, btn_om_800x600_n, Resolution7, null, null;
	button 180,200, btn_om_1024x768_c, btn_om_1024x768_o, btn_om_1024x768_n, Resolution8, null, null;
	button 180,220, btn_om_1280x960_c, btn_om_1280x960_o, btn_om_1280x960_n, Resolution9, null, null;
	button 180,260, btn_om_16bit_c, btn_om_16bit_o, btn_om_16bit_n, ScreenDepth16, null, null;
	button 180,280, btn_om_32bit_c, btn_om_32bit_o, btn_om_32bit_n, ScreenDepth32, null, null;
	button 180,320, btn_om_fullscreen_n, btn_om_fullscreen_o, btn_om_fullscreen_n, FullscreenMode, null, null;
	button 180,340, btn_om_window_c, btn_om_window_o, btn_om_window_n, WindowMode, null, null;
	
	button 360,160, btn_om_playerforward_c, btn_om_playerforward_o, btn_om_playerforward_n, setKey_PlayerForward, null, null;
	button 360,180, btn_om_playerbackward_c, btn_om_playerbackward_o, btn_om_playerbackward_n, setKey_PlayerBackward, null, null;
	button 360,200, btn_om_playerstepleft_c, btn_om_playerstepleft_o, btn_om_playerstepleft_n, setKey_PlayerStepLeft, null, null;
	button 360,220, btn_om_playerstepright_c, btn_om_playerstepright_o, btn_om_playerstepright_n, setKey_PlayerStepRight, null, null;
	button 360,240, btn_om_playerjump_c, btn_om_playerjump_o, btn_om_playerjump_n, setKey_PlayerJump, null, null;
	button 360,260, btn_om_playeruse_c, btn_om_playeruse_o, btn_om_playeruse_n, setKey_PlayerUse, null, null;
	button 360,280, btn_om_playerweapon1_c, btn_om_playerweapon1_o, btn_om_playerweapon1_n, setKey_PlayerSelectWeapon1, null, null;
	button 360,300, btn_om_playerweapon2_c, btn_om_playerweapon2_o, btn_om_playerweapon2_n, setKey_PlayerSelectWeapon2, null, null;
	button 360,320, btn_om_playerweapon3_c, btn_om_playerweapon3_o, btn_om_playerweapon3_n, setKey_PlayerSelectWeapon3, null, null;
	button 360,340, btn_om_playerweapon4_c, btn_om_playerweapon4_o, btn_om_playerweapon4_n, setKey_PlayerSelectWeapon4, null, null;
	
	button 400,380, btn_om_apply_c, btn_om_apply_o, btn_om_apply_n, ChangeOptions, null, null;
	button 220,380, btn_om_close_c, btn_om_close_o, btn_om_close_n, Optionsmenu_deactivate, null, null;
	pos_x = 2000;
	pos_y = 0;
	layer = 1;
	flags = refresh, visible;
}


// selected item in options menu -> before is a circle
panel pan_options_circle_resolution
{
	bmap = btn_om_circle;
	pos_x = -2000;
	pos_y = 0;
	layer = 3;
	flags = refresh, visible;
}


// selected item in options menu -> before is a circle
panel pan_options_circle_screendepth
{
	bmap = btn_om_circle;
	pos_x = -2000;
	pos_y = 0;
	layer = 3;
	flags = refresh, visible;
}

// selected item in options menu -> before is a circle
panel pan_options_circle_windowmode
{
	bmap = btn_om_circle;
	pos_x = -2000;
	pos_y = 0;
	layer = 3;
	flags = refresh, visible;
}

panel pan_loadgame_circle_slot
{
	bmap = btn_om_circle;
	pos_x = -2000;
	pos_y = 0;
	layer = 3;
	flags = refresh, visible;
}





panel pan_GameLoadmenu
{
	bmap = lm_bg_image;
	button 190,160, btn_slot1_normal, btn_slot1_normal, btn_slot1_over, Slot1, null, null;
	button 190,180, btn_slot2_normal, btn_slot2_normal, btn_slot2_over, Slot2, null, null;
	button 190,200, btn_slot3_normal, btn_slot3_normal, btn_slot3_over, Slot3, null, null;
	button 190,220, btn_slot4_normal, btn_slot4_normal, btn_slot4_over, Slot4, null, null;
	button 190,240, btn_slot5_normal, btn_slot5_normal, btn_slot5_over, Slot5, null, null;
	button 190,260, btn_slot6_normal, btn_slot6_normal, btn_slot6_over, Slot6, null, null;
	button 190,280, btn_slot7_normal, btn_slot7_normal, btn_slot7_over, Slot7, null, null;
	button 190,300, btn_slot8_normal, btn_slot8_normal, btn_slot8_over, Slot8, null, null;
	button 190,320, btn_slot9_normal, btn_slot9_normal, btn_slot9_over, Slot9, null, null;
	button 190,340, btn_slot10_normal, btn_slot10_normal, btn_slot10_over, Slot10, null, null;
	button 591,481, btn_lm_laden_normal, btn_lm_laden_over, btn_lm_laden_normal, GameLoad, null, null;
	button 151,481, btn_lm_close_normal, btn_lm_close_over, btn_lm_close_normal, GameLoadMenu_deactivate, null, null;
	pos_x = 2000; 
	pos_y = 0;
	layer = 1;
	flags = refresh, visible;
}

panel pan_GameSaveAsmenu
{
	bmap = sa_bg_image;
	button 500,450, btn_sa_close_c, btn_sa_close_o, btn_sa_close_n, GameSaveAsmenu_deactivate, null, null;
	button 120,160, btn_slot1_normal, btn_slot1_normal, btn_slot1_over, Slot1_save, null, null;
	button 120,180, btn_slot2_normal, btn_slot2_normal, btn_slot2_over, Slot2_save, null, null;
	button 120,200, btn_slot3_normal, btn_slot3_normal, btn_slot3_over, Slot3_save, null, null;
	button 120,220, btn_slot4_normal, btn_slot4_normal, btn_slot4_over, Slot4_save, null, null;
	button 120,240, btn_slot5_normal, btn_slot5_normal, btn_slot5_over, Slot5_save, null, null;
	button 120,260, btn_slot6_normal, btn_slot6_normal, btn_slot6_over, Slot6_save, null, null;
	button 120,280, btn_slot7_normal, btn_slot7_normal, btn_slot7_over, Slot7_save, null, null;
	button 120,300, btn_slot8_normal, btn_slot8_normal, btn_slot8_over, Slot8_save, null, null;
	button 120,320, btn_slot9_normal, btn_slot9_normal, btn_slot9_over, Slot9_save, null, null;
	button 120,340, btn_slot10_normal, btn_slot10_normal, btn_slot10_over, Slot10_save, null, null;
	pos_x = 2000; 
	pos_y = 0;
	layer = 1;
	flags = refresh, visible;
}

panel pan_SaveInfo 
{
	bmap = bmap_SaveInfo;
	pos_x = 2000;
	pos_y = 0;
	alpha = 100;
	layer = 1;
	flags = visible, refresh, transparent;
}


// shows the defined key in optionsmenu
text txt_Key_PlayerForward
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_MoveForward;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerBackward
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_MoveBackward;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerStepLeft
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_StepLeft;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerStepRight
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_StepRight;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerJump
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_Jump;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerUse
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_Use;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerSelectWeapon1
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_SelectWeapon1;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerSelectWeapon2
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_SelectWeapon2;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerSelectWeapon3
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_SelectWeapon3;
	flags = visible;
}

// shows the defined key in optionsmenu
text txt_Key_PlayerSelectWeapon4
{
	pos_x = -2000;
	pos_y = 0;
	font = font_optionsmenu;
	string = str_key_Player_SelectWeapon4;
	flags = visible;
}


// shows the "press key"-string if you redefine the keys
text txt_PressKey
{
	pos_x = -2000;
	pos_y = 300;
	font = font_optionsmenu;
	string = "press key";
	flags = visible;
}


function tri_DeactivateAreas(NumbersOfAreas)
{
	var AreaCounter;
	AreaCounter = 0;
	
	while(AreaCounter < NumbersOfAreas)
	{
		activeArea[AreaCounter] = 1; // deactivate all areas
		AreaCounter +=1;
	}
	
	
	
}



function Slot1_save()
{
	CurrentSlot = 1;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot2_save()
{
	CurrentSlot = 2;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot3_save()
{
	CurrentSlot = 3;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot4_save()
{
	CurrentSlot = 4;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot5_save()
{
	CurrentSlot = 5;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot6_save()
{
	CurrentSlot = 6;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot7_save()
{
	CurrentSlot = 7;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot8_save()
{
	CurrentSlot = 8;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot9_save()
{
	CurrentSlot = 9;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}

function Slot10_save()
{
	CurrentSlot = 10;
	GameSaveAsmenu_deactivate();
	menu_active = 0;
	Save_Game();
}




function Save_Game()       
{
	if (menu_active == 0)          
	{
		if (CurrentSlot == 1)    
		{
			wait(1);
			game_save("save",1,sv_all);   // save game
			wait(1);
	
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 2)
		{
			wait(1);
			game_save("save",2,sv_all);
			wait(1);
	
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 3)
		{
			wait(1);
			game_save("save",3,sv_all);
			wait(1);
	
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 4)
		{
			wait(1);
			game_save("save",4,sv_all);
			wait(1);
	
	
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 5)
		{
			wait(1);
			game_save("save",5,sv_all);
			wait(1);
		
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 6)
		{
			wait(1);
			game_save("save",6,sv_all);
			wait(1);
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 7)
		{
			wait(1);
			game_save("save",7,sv_all);
			wait(1);
			
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 8)
		{
			wait(1);
			game_save("save",8,sv_all);
			wait(1);
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 9)
		{
			wait(1);
			game_save("save",9,sv_all);
			wait(1);
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
		if (CurrentSlot == 10)
		{
			wait(1);
			game_save("save",10,sv_all);
			wait(1);
		
			pan_SaveInfo.pos_x = 0; 
			pan_SaveInfo.scale_x = (Screen_Size.x+1) / 800;
			pan_SaveInfo.scale_y = (Screen_Size.y+1) / 600;
			wait(4);
			while(pan_SaveInfo.alpha > 0) 
			{
				pan_SaveInfo.alpha -= 5 * time;
				wait(1);
			}
			wait(4);
			pan_SaveInfo.pos_x = 2000; 
			pan_SaveInfo.alpha = 100;  
		}
		
	}
}



function GameSaveAs()
{
	GameSaveAsmenu_activate();
}

function Gameload()
{
	if (CurrentSlot == 1)
	{
		if (game_load("save",1) > 0)
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 2)
	{
		if (game_load("save",2) > 0)
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 3)
	{
		if (game_load("save",3) > 0)
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 4)
	{
		if (game_load("save",4) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 5)
	{
		if (game_load("save",5) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 6)
	{
		if (game_load("save",6) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 7)
	{
		if (game_load("save",7) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 8)
	{
		if (game_load("save",8) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 9)
	{
		if (game_load("save",9) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	if (CurrentSlot == 10)
	{	
		if (game_load("save",10) > 0 )
		{
			pan_loadgame_circle_slot.pos_x = -2000;
			snd_stop(hm_bg_music_handle);
		}
	}
	
	Options_load();        // the game_save function saves also the used keys -> thats not good -> they must be set new
}


function Slot1
{
	CurrentSlot = 1;
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 160 * ( Screen_Size.y ) / 600;
}

function Slot2
{
	CurrentSlot = 2;
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 180 * ( Screen_Size.y ) / 600;
}

function Slot3
{
	CurrentSlot = 3; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 200 * ( Screen_Size.y ) / 600;
}

function Slot4
{
	CurrentSlot = 4; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 220 * ( Screen_Size.y ) / 600;
}

function Slot5
{
	CurrentSlot = 5; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 240 * ( Screen_Size.y ) / 600;
}

function Slot6
{	
	CurrentSlot = 6;  
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 260 * ( Screen_Size.y ) / 600;
}

function Slot7
{
	CurrentSlot = 7; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 280 * ( Screen_Size.y ) / 600;
}

function Slot8
{	
	CurrentSlot = 8; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 300 * ( Screen_Size.y ) / 600;
}

function Slot9
{
	CurrentSlot = 9; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 320 * ( Screen_Size.y ) / 600;
}

function Slot10
{
	CurrentSlot = 10; 
	pan_loadgame_circle_slot.scale_x = ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.scale_y = ( Screen_Size.y ) / 600;
	pan_loadgame_circle_slot.pos_x = 173 * ( Screen_Size.x ) / 800;
	pan_loadgame_circle_slot.pos_y = 340 * ( Screen_Size.y ) / 600;
}

function load_level1()
{
	Statusbar.pos_x = 0;
	CurrentSlot = 0;
	mainmenu_deactivate();
	level_load(str_level_1);
	Weapon_SetStartValues();
	wait(4);
	
	
	
	tri_DeactivateAreas(100);
	menu_active = 0;
	activeArea[1] = 0; // at level start: area 1 is active
	
	
	
	Report_lvl1[0] = 0;
	Report_lvl1[1] = 0;
	Report_lvl1[2] = 0;
	Report_lvl1[3] = 0;
	Report_lvl1[4] = 0;
	
	lvl1_ReportsFound = 0;
	
	snd_stop(hm_bg_music_handle);	
}


function load_level2()
{
	tri_DeactivateAreas(100);
	menu_active = 0;
	activeArea[1] = 0; // at level start: area 1 is active
	Statusbar.pos_x = 0;
	CurrentSlot = 0;
	mainmenu_deactivate();

	wait(1);
	level_load(str_level_2);
	wait(1);
	
	
	Report_lvl2[0] = 0;
	Report_lvl2[1] = 0;
	Report_lvl2[2] = 0;
	Report_lvl2[3] = 0;
	Report_lvl2[4] = 0;
	
	lvl2_ReportsFound = 0;
	
}

function load_level0()
{
	mouse_speed_x = mouse_speed_normal_x;
	mouse_speed_y = mouse_speed_normal_y;
	tri_DeactivateAreas(100);
	Weapon_SetStartValues();
	camera.arc = 60;
	Statusbar.pos_x = -2000;
	panel_slash.pos_x = -2000;
	Panel_ValuesWeapon1.pos_x = -2000;
	Panel_ValuesWeapon2.pos_x = -2000;
	Panel_ValuesWeapon3.pos_x = -2000;
	Panel_ValuesWeapon4.pos_x = -2000;
	pan_Health_Player.pos_x = -2000;

	level_load(str_level_start);
	
	if (snd_playing(hm_bg_music_handle) == 0)
	{
		hm_bg_music_handle = snd_loop(hm_bg_music,100,0);
	}
	
	mainmenu_activate();
	pausemenu_deactivate();
	
	
	menu_active = 1;
	
	
	Report_lvl2[0] = 0;
	Report_lvl2[1] = 0;
	Report_lvl2[2] = 0;
	Report_lvl2[3] = 0;
	Report_lvl2[4] = 0;
	
	lvl2_ReportsFound = 0;
}

function resume()
{
	mainmenu_deactivate();
	pausemenu_deactivate();
	mainmenu_active = 0;
	pausemenu_active = 0;
	optionsmenu_active = 0;
	menu_active = 0;
	camera.arc = 60;
}

function opt2ionsmenu_activate()
{
	
	mainmenu_deactivate();
	pausemenu_deactivate();
	optionsmenu_activate();
}


function GameExit()
{
	exit;
}

function mainmenu_deactivate()
{
	pan_mainmenu.pos_x = 2000;
	mainmenu_active = 0;
	pausemenu_active = 0;
	Menu_active = 0;
}

function pausemenu_deactivate()
{
	pan_pausemenu.pos_x = 2000;
	pausemenu_active = 0;
	mainmenu_active = 0;
	pan_pausemenu.scale_x = (Screen_Size.x+1) / 800;
	pan_pausemenu.scale_y = (Screen_Size.y+1) / 600;
	
	Menu_active = 0;
}

function optionsmenu_activate()
{
	pan_options.pos_x = 0;
	mainmenu_deactivate();
	pausemenu_active = 0;
	mainmenu_active = 0;
	optionsmenu_active = 1;
	menu_active = 1;
	pan_options.scale_x = (Screen_Size.x+1) / 800;
	pan_options.scale_y = (Screen_Size.y+1) / 600;
	
	Options_load();
	
	// display the stored keys in options menu
	
	txt_Key_PlayerForward.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerForward.pos_y = 160 * ( screen_size.y / 600);
	
	txt_Key_PlayerBackward.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerBackward.pos_y = 180 * ( screen_size.y / 600);
	
	txt_Key_PlayerStepLeft.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerStepLeft.pos_y = 200 * ( screen_size.y / 600);
	
	txt_Key_PlayerStepRight.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerStepRight.pos_y = 220 * ( screen_size.y / 600);
	
	txt_Key_PlayerJump.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerJump.pos_y = 240 * ( screen_size.y / 600);
	
	txt_Key_PlayerUse.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerUse.pos_y = 260 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon1.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon1.pos_y = 280 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon2.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon2.pos_y = 300 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon3.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon3.pos_y = 320 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon4.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon4.pos_y = 340 * ( screen_size.y / 600);
	
	
	//display the stored values in options menu ( resolution, screendepth, window-/fullscreenmode )
	
	if (NewResolution == 6)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 160 * ( Screen_Size.y ) / 600;
	}
	
	if (NewResolution == 7)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 180 * ( Screen_Size.y ) / 600;
	}
	
	if (NewResolution == 8)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 200 * ( Screen_Size.y ) / 600;
	}
	
	if (NewResolution == 9)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 220 * ( Screen_Size.y ) / 600;
	}
	
	if (NewScreenDepth == 16)
	{
		pan_options_circle_screendepth.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_screendepth.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.pos_y = 260 * ( Screen_Size.y ) / 600;
	}
	
	if (NewScreenDepth == 32)
	{
		pan_options_circle_screendepth.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_screendepth.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.pos_y = 280 * ( Screen_Size.y ) / 600;
	}
	
	if (NewWindowMode == 1)
	{
		pan_options_circle_windowmode.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_windowmode.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.pos_y = 320* ( Screen_Size.y ) / 600;
	}
	
	if (NewWindowMode == 2)
	{
		pan_options_circle_windowmode.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_windowmode.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.pos_y = 340* ( Screen_Size.y ) / 600;
	}
	
	
}

function optionsmenu_deactivate()
{
	pan_options.pos_x = 2000;
	pausemenu_active = 0;
	mainmenu_active = 1;
	optionsmenu_active = 0;
	mainmenu_activate();
	pausemenu_deactivate();
	menu_active = 1;
	
	// move all panels used in options menu out of the screen 
	txt_Key_PlayerForward.pos_x = -2000;
	txt_Key_PlayerBackward.pos_x = -2000;
	txt_Key_PlayerStepLeft.pos_x = -2000;
	txt_Key_PlayerStepRight.pos_x = -2000;
	txt_Key_PlayerJump.pos_x = -2000;
	txt_Key_PlayerUse.pos_x = -2000;
	txt_Key_PlayerSelectWeapon1.pos_x = -2000;
	txt_Key_PlayerSelectWeapon2.pos_x = -2000;
	txt_Key_PlayerSelectWeapon3.pos_x = -2000;
	txt_Key_PlayerSelectWeapon4.pos_x = -2000;
	
	pan_options_circle_resolution.pos_x = -2000;
	pan_options_circle_screendepth.pos_x = -2000;
	pan_options_circle_windowmode.pos_x = -2000;
}

function GameLoadMenu_activate()
{
	pan_GameLoadmenu.pos_x = 0;
	GameLoadmenu_active = 1;
	mainmenu_active = 0;
	optionsmenu_active = 0;
	mainmenu_deactivate();
	menu_active = 1;
	pan_GameLoadmenu.scale_x = (Screen_Size.x+1) / 800;
	pan_GameLoadmenu.scale_y = (Screen_Size.y+1) / 600;
}

function GameLoadmenu_deactivate()
{
	pan_GameLoadmenu.pos_x = -2000;
	pan_loadgame_circle_slot.pos_x = -2000;
	GameLoadmenu_active = 0;
	mainmenu_active = 1;
	optionsmenu_active = 0;
	pausemenu_active = 0;
	pausemenu_deactivate();
	mainmenu_activate();
	menu_active = 1;
}

function mainmenu_activate()
{
	pan_mainmenu.pos_x = 0;
	mainmenu_active = 1;
	pausemenu_active = 0;
	menu_active = 1;
	pan_mainmenu.scale_x = (Screen_Size.x+1) / 800;
	pan_mainmenu.scale_y = (Screen_Size.y+1) / 600;	
}

function pausemenu_activate()
{
	pan_pausemenu.pos_x = 0;
	pausemenu_active = 1;
	mainmenu_active = 0;
	
	menu_active = 1;
	pan_pausemenu.scale_x = (Screen_Size.x+1) / 800;
	pan_pausemenu.scale_y = (Screen_Size.y+1) / 600;
}

function GameSaveAsmenu_deactivate()
{
	pan_GameSaveAsmenu.pos_x = 2000;
	pausemenu_deactivate();
	menu_active = 0;
}

function GameSaveAsmenu_activate()
{
	pausemenu_deactivate();
	menu_active = 1;
	pan_GameSaveAsmenu.pos_x = 0;
	pan_GameSaveAsmenu.scale_x = (Screen_Size.x+1) / 800;
	pan_GameSaveAsmenu.scale_y = (Screen_Size.y+1) / 600;
}

function Resolution6()
{
	NewResolution = 6;
	
	pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.pos_y = 160 * ( Screen_Size.y ) / 600;
}

function Resolution7()
{
	NewResolution = 7;
	
	pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.pos_y = 180 * ( Screen_Size.y ) / 600;
}

function Resolution8()
{
	NewResolution = 8;
	
	pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.pos_y = 200 * ( Screen_Size.y ) / 600;
}

function Resolution9()
{
	NewResolution = 9;
	
	pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_resolution.pos_y = 220 * ( Screen_Size.y ) / 600;
}

function ScreenDepth16()
{
	NewScreenDepth = 16;
	pan_options_circle_screendepth.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_screendepth.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_screendepth.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_screendepth.pos_y = 260 * ( Screen_Size.y ) / 600;
}

function ScreenDepth32()
{
	NewScreenDepth = 32;
	
	pan_options_circle_screendepth.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_screendepth.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_screendepth.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_screendepth.pos_y = 280 * ( Screen_Size.y ) / 600;
}

function FullScreenMode()
{
	NewWindowMode = 1;
	
	pan_options_circle_windowmode.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_windowmode.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_windowmode.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_windowmode.pos_y = 320* ( Screen_Size.y ) / 600;
}

function WindowMode()
{
	NewWindowMode = 2;
	
	pan_options_circle_windowmode.scale_x = ( Screen_Size.x ) / 800;
	pan_options_circle_windowmode.scale_y = ( Screen_Size.y ) / 600;
	pan_options_circle_windowmode.pos_x = 160 * ( Screen_Size.x ) / 800;
	pan_options_circle_windowmode.pos_y = 340* ( Screen_Size.y ) / 600;
}

function ChangeOptions()
{
	video_switch(NewResolution,NewScreenDepth,NewWindowMode);
	pan_options.scale_x = (Screen_Size.x+1) / 800;
	pan_options.scale_y = (Screen_Size.y+1) / 600;
	pan_pausemenu.scale_x = (Screen_Size.x+1) / 800;
	pan_pausemenu.scale_y = (Screen_Size.y+1) / 600;
	pan_mainmenu.scale_x = (Screen_Size.x+1) / 800;
	pan_mainmenu.scale_y = (Screen_Size.y+1) / 600;
	pan_GameLoadmenu.scale_x = (Screen_Size.x+1) / 800;
	pan_GameLoadmenu.scale_y = (Screen_Size.y+1) / 600;
	
	
	// load all stored game options from "options.sav"
	filehandle_options = file_open_write(file_options);
	file_var_write(filehandle_options,NewResolution);
	file_var_write(filehandle_options,NewScreenDepth);
	file_var_write(filehandle_options,NewWindowMode);
	
	file_var_write(filehandle_options,key_Player_MoveForward);
	file_var_write(filehandle_options,key_Player_MoveBackward);
	file_var_write(filehandle_options,key_Player_StepLeft);
	file_var_write(filehandle_options,key_Player_StepRight);
	
	file_var_write(filehandle_options,key_Player_Jump);
	file_var_write(filehandle_options,key_Player_Use);
	
	file_var_write(filehandle_options,key_Player_SelectWeapon1);
	file_var_write(filehandle_options,key_Player_SelectWeapon2);
	file_var_write(filehandle_options,key_Player_SelectWeapon3);
	file_var_write(filehandle_options,key_Player_SelectWeapon4);
	
	file_close(filehandle_options);
	
	
	// if you change the resolution the text elements position must also be set 
	
	txt_Key_PlayerForward.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerForward.pos_y = 160 * ( screen_size.y / 600);
	
	txt_Key_PlayerBackward.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerBackward.pos_y = 180 * ( screen_size.y / 600);
	
	txt_Key_PlayerStepLeft.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerStepLeft.pos_y = 200 * ( screen_size.y / 600);
	
	txt_Key_PlayerStepRight.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerStepRight.pos_y = 220 * ( screen_size.y / 600);
	
	txt_Key_PlayerJump.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerJump.pos_y = 240 * ( screen_size.y / 600);
	
	txt_Key_PlayerUse.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerUse.pos_y = 260 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon1.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon1.pos_y = 280 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon2.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon2.pos_y = 300 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon3.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon3.pos_y = 320 * ( screen_size.y / 600);
	
	txt_Key_PlayerSelectWeapon4.pos_x = 500 * ( screen_size.x / 800);
	txt_Key_PlayerSelectWeapon4.pos_y = 340 * ( screen_size.y / 600);
	
	
	// if you change the resolution the panel elements position must also be set 
	
	if (NewResolution == 6)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 160 * ( Screen_Size.y ) / 600;
	}
	
	if (NewResolution == 7)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 180 * ( Screen_Size.y ) / 600;
	}
	
	if (NewResolution == 8)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 200 * ( Screen_Size.y ) / 600;
	}
	
	if (NewResolution == 9)
	{
		pan_options_circle_resolution.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_resolution.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_resolution.pos_y = 220 * ( Screen_Size.y ) / 600;
	}
	
	if (NewScreenDepth == 16)
	{
		pan_options_circle_screendepth.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_screendepth.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.pos_y = 260 * ( Screen_Size.y ) / 600;
	}
	
	if (NewScreenDepth == 32)
	{
		pan_options_circle_screendepth.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_screendepth.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_screendepth.pos_y = 280 * ( Screen_Size.y ) / 600;
	}
	
	if (NewWindowMode == 1)
	{
		pan_options_circle_windowmode.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_windowmode.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.pos_y = 320* ( Screen_Size.y ) / 600;
	}
	
	if (NewWindowMode == 2)
	{
		pan_options_circle_windowmode.scale_x = ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.scale_y = ( Screen_Size.y ) / 600;
		pan_options_circle_windowmode.pos_x = 160 * ( Screen_Size.x ) / 800;
		pan_options_circle_windowmode.pos_y = 340* ( Screen_Size.y ) / 600;
	}
	
	
}

function Options_load()    // load game options
{
	filehandle_options = file_open_read(file_options);
	NewResolution = file_var_read(filehandle_options);
	NewScreenDepth = file_var_read(filehandle_options);
	NewWindowMode = file_var_read(filehandle_options);
	
	key_Player_MoveForward = file_var_read(filehandle_options);
	key_Player_MoveBackward = file_var_read(filehandle_options);
	key_Player_StepLeft = file_var_read(filehandle_options);
	key_Player_StepRight = file_var_read(filehandle_options);
	
	key_Player_Jump = file_var_read(filehandle_options);
	key_Player_Use = file_var_read(filehandle_options);
	
	key_Player_SelectWeapon1 = file_var_read(filehandle_options);
	key_Player_SelectWeapon2 = file_var_read(filehandle_options);
	key_Player_SelectWeapon3 = file_var_read(filehandle_options);
	key_Player_SelectWeapon4 = file_var_read(filehandle_options);
	
	file_close(filehandle_options);
	video_switch(NewResolution,NewScreenDepth,NewWindowMode);
	
	
	// convert key-scancodes to strings
	str_for_key(str_key_Player_MoveForward, key_Player_MoveForward);
	str_for_key(str_key_Player_MoveBackward, key_Player_MoveBackward);
	str_for_key(str_key_Player_StepLeft, key_Player_StepLeft);
	str_for_key(str_key_Player_StepRight, key_Player_StepRight);
	str_for_key(str_key_Player_Jump, key_Player_Jump);
	str_for_key(str_key_Player_Use, key_Player_Use);
	str_for_key(str_key_Player_SelectWeapon1, key_Player_SelectWeapon1);
	str_for_key(str_key_Player_SelectWeapon2, key_Player_SelectWeapon2);
	str_for_key(str_key_Player_SelectWeapon3, key_Player_SelectWeapon3);
	str_for_key(str_key_Player_SelectWeapon4, key_Player_SelectWeapon4);
	
	
}


// if you click in options menu to redefine the keys

function setKey_PlayerForward()
{
	sleep(0.5);
	key_define_Player_MoveForward = 1;
	txt_Key_PlayerForward.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 160 * ( screen_size.y / 600 );
	
}

function setKey_PlayerBackward()
{
	sleep(0.5);
	key_define_Player_MoveBackward = 1;
	txt_Key_PlayerBackward.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 180 * ( screen_size.y / 600 );
	
}

function setKey_PlayerStepLeft()
{
	sleep(0.5);
	key_define_Player_StepLeft = 1;
	txt_Key_PlayerStepLeft.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 200 * ( screen_size.y / 600 );
}

function setKey_PlayerStepRight()
{
	sleep(0.5);
	key_define_Player_StepRight = 1;
	txt_Key_PlayerStepRight.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 220 * ( screen_size.y / 600 );
}

function setKey_PlayerJump()
{
	sleep(0.5);
	key_define_Player_Jump = 1;
	txt_Key_PlayerJump.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 240 * ( screen_size.y / 600 );
}

function setKey_PlayerUse()
{
	sleep(0.5);
	key_define_Player_Use = 1;
	txt_Key_PlayerUse.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 260 * ( screen_size.y / 600 );
}

function setKey_PlayerSelectWeapon1()
{
	sleep(0.5);
	key_define_Player_SelectWeapon1 = 1;
	txt_Key_PlayerSelectWeapon1.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 280 * ( screen_size.y / 600 );
}

function setKey_PlayerSelectWeapon2()
{
	sleep(0.5);
	key_define_Player_SelectWeapon2 = 1;
	txt_Key_PlayerSelectWeapon2.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 300 * ( screen_size.y / 600 );
}

function setKey_PlayerSelectWeapon3()
{
	sleep(0.5);
	key_define_Player_SelectWeapon3 = 1;
	txt_Key_PlayerSelectWeapon3.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 320 * ( screen_size.y / 600 );
}

function setKey_PlayerSelectWeapon4()
{
	sleep(0.5);
	key_define_Player_SelectWeapon4 = 1;
	txt_Key_PlayerSelectWeapon4.pos_x = -2000;
	txt_PressKey.pos_x = 500 * ( screen_size.x / 800 );
	txt_PressKey.pos_y = 340 * ( screen_size.y / 600 );
}