

// level definitions
string str_level_start = <NoReturn.wmb>;  
string str_level_1     = <level_1.wmb>;
string str_level_2     = <level_2.wmb>;


// mouse speed ( normal speed -> slow in weapon3 zoom mode )

var mouse_speed_normal_x = 10;           // normal mouse speed x
var mouse_speed_normal_y = 6;            // normal mouse speed y
var mouse_speed_Weapon3ZoomMode_x = 1;   // mouse speed in Weapon3ZoomMode x
var mouse_speed_Weapon3ZoomMode_y = 1;   // mouse speed in Weapon3ZoomMode y

var mouse_speed_x;
var mouse_speed_y;


// menusystem
var menu_active = 0;
var mainmenu_active = 0;
var pausemenu_active = 0;
var optionsmenu_active = 0;
var gameloadmenu_active = 0;


// these values are changed in options menu
var NewResolution = 0;
var NewScreenDepth = 0;
var NewWindowMode = 0;

sound snd_kanalgitter = <kanalgitter.wav>;  // door sound
var_nsave snd_kanalgitter_handle;




// KEY DEFINITION
// used with the key_pressed()-function and ...
// ... the key-change-function in options menu -> these variables are the connection 



// values for key_pressed()-function
var key_Player_MoveForward; 
var key_Player_MoveBackward;  
var key_Player_StepLeft;     
var key_Player_StepRight;
var key_Player_Jump;        
var key_Player_Use;           
var key_Player_SelectWeapon1;
var key_Player_SelectWeapon2;
var key_Player_SelectWeapon3;
var key_Player_SelectWeapon4;


// converted scancodes are stored in these variables
string str_key_Player_MoveForward;
string str_key_Player_MoveBackward;
string str_key_Player_StepLeft;
string str_key_Player_StepRight;
string str_key_Player_Jump;
string str_key_Player_Use;
string str_key_Player_SelectWeapon1;
string str_key_Player_SelectWeapon2;
string str_key_Player_SelectWeapon3;
string str_key_Player_SelectWeapon4;


// used to define keys -> in options menu if you see "press key" 
var key_define_Player_MoveForward   = 0;
var key_define_Player_MoveBackward  = 0;
var key_define_Player_StepLeft      = 0;
var key_define_Player_StepRight     = 0;
var key_define_Player_Jump          = 0;
var key_define_Player_Use           = 0;
var key_define_Player_SelectWeapon1 = 0;
var key_define_Player_SelectWeapon2 = 0;
var key_define_Player_SelectWeapon3 = 0;
var key_define_Player_SelectWeapon4 = 0;




// files

var_nsave filehandle_options;
string file_options = <options.sav>;    // save game options



// save slots

var CurrentSlot = 0;


// weapons

var Weapon_Available[4];           
var Weapon_active[4];              
var Weapon_MaxAmmo[4];       
var Weapon_CurrentAmmo[4];          
var Weapon_ShotFrequency[4];        // shot per second

var Weapon_DistanceToObstacle;      // weapon not inside the walls -> distance between player and obstacle


// area / trigger

var activeArea[100];



function RoundValue(value)
{
	if (frc(value) >= 0.5)
	{
		return(int(value) + 1);
	}
	else
	{
		return(int(value));
	}
}

// doors

var DoorOpenWithNumber[99]; 
var Door_IsMoving[99];      
var Door_Wait[99];

// elevator

var ActivateElevatorWithNumber[99];
var Elevator_IsMoving[99];
var Elevator_Wait[99];


// special objects

var SpecialObject_ActivateWithNumber[99];
var SpecialObject_IsMoving[99];
var SpecialObject_Wait[99];


// level goals


// Level 1: .............
// find all reports

var report_lvl1[5] = 0,0,0,0,0;  // find all reports to complete the level
                              
                               
var lvl1_ReportsFound = 0;
var lvl1_ReportsNumber = 5;                              


// Level 2: .............
// find all reports


var report_lvl2[5] = 0,0,0,0,0;  // find all reports to complete the level
    


var lvl2_ReportsFound = 0;
var lvl2_ReportsNumber = 5;

