include <structures.wdl>;


sound kanalis_bg_sound = <bgkanalisation2.wav>;
var_nsave kanalis_bg_sound_handle;

material mat_kanaliswasser
{
	ambient_red = 70;
	ambient_green = 70;
	ambient_blue = 70;
	
	ambient_red = 200;
	ambient_green = 200;
	ambient_blue = 200;
	
	diffuse_red = 0;
	diffuse_green = 0;
	diffuse_blue = 0;
	
	specular_red = 0;
	specular_green = 0;
	specular_blue = 0;
	
	emissive_red = 0;
	emissive_green = 0;
	emissive_blue = 0;
	albedo = 80;
}

action kanaliswasser
{
	my.oriented = on;
	my.material = mat_kanaliswasser;
	my.alpha = 85;
	while(1)
	{
		if (menu_active == 0)
		{
			my.u += 20 * time;
		}
		wait(1);
	}
}


define Area, skill1;
define Speed, skill2;
//uses: Area, Speed;
action kanal_w_fall 
{
	my.material = mat_kanaliswasser;
	my.transparent = on;
	my.passable = on;
	my.alpha = 85;
	while(1)
	{
		if (activeArea[my.Area] == 0)  // combine water with area
		{
			my.invisible = off;   
			
			if (my.Speed > 0)     // if speed > 0 then animate water
			{
				if (menu_active == 0)
				{
					my.u -= my.Speed * time;
				}
			}
		}
		else
		{
			my.invisible = on;   // deavtivate if area is not active
		}
		wait(1);
	}
}


define Area, skill1;
define Speed, skill2;
//uses: Area, Speed;
action kanal_w_fall2
{
	my.material = mat_kanaliswasser;
	my.transparent = on;
	my.passable = on;
	my.alpha = 85;
	
	my.skill3 = 0;
	
	while(1)
	{
		my.skill4 = vec_dist(player.x, my.x);
		if (my.skill4 < 1400)
		{
			if (!snd_playing(kanalis_bg_sound_handle))
			{
				kanalis_bg_sound_handle = ent_playsound(my,kanalis_bg_sound, 300);
				snd_tune(kanalis_bg_sound_handle, 0, 0, 1);
			}
				
				
		}
		
		
		
		if (activeArea[my.Area] == 0)  // combine water with area
		{
			my.invisible = off;   // ... 
			
			if (my.Speed > 0)     // if speed > 0 then animate water
			{
				if (menu_active == 0)
				{
				
				my.u += my.Speed * time;
				}
			}
		}
		else
		{
			my.invisible = on;   // deavtivate if area is not active
		}
		
		wait(1);
	}
	
}